/*
 * $Id: extprocs.c,v 1.5 2004/12/30 09:07:47 ali Exp $
 * Copyright (C) 2007 J. Ali Harlow
 * Min Hack may be freely redistributed.  See license for details. 
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "minhack.h"

struct nhproxy_cb_get_glyph_mapping_res *glyph_map;
struct minhack_window *windows=NULL;
int no_windows=0;

static int v_hook(void)
{
    fprintf(stderr,"v_hook called\n");
}

struct nhproxy_clnt_ext_procs minhack_ext_procs = {
    "minhack",
    minhack_init_nhwindows,
    minhack_player_selection,
    minhack_askname,
    NULL,			/* get_nh_event */
    minhack_exit_nhwindows,
    NULL,			/* suspend_nhwindows */
    NULL,			/* resume_nhwindows */
    minhack_create_nhwindow,
    minhack_clear_nhwindow,
    minhack_display_nhwindow,
    minhack_destroy_nhwindow,
    minhack_curs,
    minhack_putstr,
    minhack_display_file,
    minhack_start_menu,
    minhack_add_menu,
    minhack_end_menu,
    minhack_select_menu,
    minhack_message_menu,
    NULL,			/* update_inventory */
    NULL,			/* mark_sync */
    NULL,			/* wait_sync */
    NULL,			/* cliparound */
    NULL,			/* update_positionbar */
    minhack_print_glyph,
    minhack_raw_print,
    minhack_raw_print_bold,
    minhack_nhgetch,
    minhack_nh_poskey,
    NULL,			/* nhbell */
    NULL,			/* doprev_message */
    minhack_yn_function,
    minhack_getlin,
    minhack_get_ext_cmd,
    NULL,			/* number_pad */
    NULL,			/* delay_output */
    NULL,			/* change_color */
    NULL,			/* change_background */
    NULL,			/* set_font_name */
    NULL,			/* get_color_string */
    NULL,			/* start_screen,*/
    NULL,			/* end_screen,*/
    minhack_outrip,
    minhack_preference_update,
    NULL,			/* status */
    v_hook,			/* print_glyph_layered */
    minhack_send_config_file,
};

int minhack_init_nhwindows(int *argc, char **argv, char ***capv)
{
    initscr();
    nonl();
    cbreak();
    noecho();
    refresh();
    glyph_map=nhproxy_cb_get_glyph_mapping();
    return nhproxy_true;
}

int minhack_player_selection(int *role, int *race, int *gend, int *align)
{
    return nhproxy_false;
}

char *minhack_askname(void)
{
    return "ali";
}

void minhack_exit_nhwindows(const char *str)
{
    endwin();
    minhack_raw_print(str);
}

void minhack_curs(int window, int x, int y)
{
    wmove(windows[window].win,y,x);
}

void minhack_putstr(int window, int attr, const char *str)
{
    waddstr(windows[window].win,str);
}

void minhack_display_file(int fh)
{
    /* FIXME: Implement */
}

void minhack_print_glyph(int id, int x, int y, int glyph)
{
    struct nhproxy_glyph_map_info info;
    struct nhproxy_glyph_mapping *map;
    map=nhproxy_glyph_map_first(&info,glyph_map);
    while(glyph--)
	map=nhproxy_glyph_map_next(&info);
    mvwaddch(windows[id].win,y,x,map->rgbsym&0xFF);
    nhproxy_glyph_map_close(&info);
}

void minhack_raw_print(const char *str)
{
    if (*str)
	puts(str);
}

void minhack_raw_print_bold(const char *str)
{
    minhack_raw_print(str);
}

int minhack_nhgetch(void)
{
    int i;
    for(i=0;i<no_windows;i++)
	if (windows[i].win && windows[i].type!=NHPROXY_EXT_NHW_MENU &&
	  windows[i].type!=NHPROXY_EXT_NHW_TEXT)
	    wrefresh(windows[i].win);
    return getch();
}

int minhack_nh_poskey(int *x, int *y, int *mod)
{
    return minhack_nhgetch();
}

int minhack_outrip(int window, char *killed_by)
{
    return nhproxy_false;
}

void minhack_preference_update(const char *optnam, const char *value)
{
}

void minhack_send_config_file(int fh)
{
}
